TVportData::TVportData() {
  memset(this, 0, sizeof(TVportData));
}//---------------------------------------------------------
TVportData::TVportData(LPDIRECT3DRMVIEWPORT Ivport){
  Save(Ivport);
}//---------------------------------------------------------
void TVportData::Save() {
  Save(SavedPort);
}//---------------------------------------------------------
void TVportData::Save(LPDIRECT3DRMVIEWPORT Ivport) {
  if (!Ivport) return;
  SavedPort      = Ivport;
  projection = Ivport->GetProjection();
  uniform    = Ivport->GetUniformScaling();
  back       = Ivport->GetBack();
  front      = Ivport->GetFront();
  field      = Ivport->GetField();
  Ivport->GetCamera(&camera);
  Ivport->GetPlane(&left, &right, &bottom, &top);
}//---------------------------------------------------------
void TVportData::Restore() {
  Restore(SavedPort);
}//---------------------------------------------------------
void TVportData::Restore(LPDIRECT3DRMVIEWPORT Ivport) {
  if (!Ivport || !SavedPort) return;
  SavedPort = Ivport;
  Ivport->SetProjection(projection);
  Ivport->SetUniformScaling(uniform);
  Ivport->SetBack(back);
  Ivport->SetFront(front);
  Ivport->SetField(field);
  Ivport->SetCamera(camera);
  Ivport->SetPlane(left, right, bottom, top);
}//---------------------------------------------------------
